"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _moment = _interopRequireDefault(require("moment"));

require("moment/locale/zh-cn");

var _datePicker = _interopRequireDefault(require("antd/lib/date-picker"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

_moment["default"].locale('zh-cn');

var cm_style = {
  error: 'vtx-ui-date-error'
};

function VtxDatePicker(props) {
  var showTime = props.showTime,
      format = props.format,
      allowClear = props.allowClear,
      disabled = props.disabled,
      open = props.open,
      showToday = props.showToday,
      value = props.value,
      placeholder = props.placeholder,
      size = props.size,
      style = props.style,
      disabledDate = props.disabledDate,
      onChange = props.onChange,
      onOpenChange = props.onOpenChange,
      disabledTime = props.disabledTime,
      onOk = props.onOk,
      required = props.required;

  var DatePickerProps = _objectSpread(_objectSpread({}, props), {}, {
    allowClear: allowClear || false,
    showTime: showTime || false,
    disabled: disabled || false,
    showToday: showToday || false,
    format: format || (!showTime ? 'YYYY-MM-DD' : 'YYYY-MM-DD HH:mm:ss'),
    value: value ? (0, _moment["default"])(value, format || (!showTime ? 'YYYY-MM-DD' : 'YYYY-MM-DD HH:mm:ss')) : null,
    style: style || {},
    placeholder: placeholder || '请选择时间',
    size: size || 'default',
    onChange: onChange,
    onOpenChange: onOpenChange,
    disabledTime: disabledTime,
    onOk: onOk
  });

  if ('open' in props) {
    DatePickerProps.open = open;
  }

  if ('disabledDate' in props) {
    if (typeof disabledDate === 'function') {
      DatePickerProps.disabledDate = disabledDate;
    } // DatePickerProps.disabledDate = disabledDateFun;

  }

  if (required && !value) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: cm_style.error,
      "data-errorMsg": "\u5FC5\u586B"
    }, /*#__PURE__*/_react["default"].createElement(_datePicker["default"], DatePickerProps));
  } else {
    return /*#__PURE__*/_react["default"].createElement(_datePicker["default"], DatePickerProps);
  }
}

var _default = VtxDatePicker; //后期完善功能
// function disabledDateFun(current) {
//     let isTrue = false;
//     if(!current) return isTrue;
//     switch(disabledDate.type){
//         case 'equ'://等于
//             isTrue = disabledDate.date.indexOf(moment(current).format(DatePickerProps.format)) > -1;
//         break;
//         case 'lss'://小于
//             isTrue = current.valueOf() < moment(disabledDate.date).valueOf();
//         break;
//         case 'les'://小于等于
//             isTrue = current.valueOf() <= moment(disabledDate.date).valueOf();
//         break;
//         case 'gt'://大于
//             isTrue = current.valueOf() > moment(disabledDate.date).valueOf();
//         break;
//         case 'geq'://大于等于
//             isTrue = current.valueOf() >= moment(disabledDate.date).valueOf();
//         break;
//     }
//     return isTrue;
// }

exports["default"] = _default;
module.exports = exports["default"];
//# sourceMappingURL=VtxDatePicker.js.map
