"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _moment = _interopRequireDefault(require("moment"));

require("moment/locale/zh-cn");

var _datePicker = _interopRequireDefault(require("antd/lib/date-picker"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

_moment["default"].locale('zh-cn');

var cm_style = {
  error: 'vtx-ui-date-error'
};
var RangePicker = _datePicker["default"].RangePicker;

function VtxRangePicker(props) {
  var showTime = props.showTime,
      format = props.format,
      allowClear = props.allowClear,
      disabled = props.disabled,
      open = props.open,
      value = props.value,
      placeholder = props.placeholder,
      size = props.size,
      style = props.style,
      disabledDate = props.disabledDate,
      required = props.required,
      _onChange = props.onChange,
      onOpenChange = props.onOpenChange,
      disabledTime = props.disabledTime,
      onOk = props.onOk;

  var DatePickerProps = _objectSpread(_objectSpread({}, props), {}, {
    allowClear: allowClear || false,
    showTime: showTime || false,
    disabled: disabled || false,
    format: format || (!showTime ? 'YYYY-MM-DD' : 'YYYY-MM-DD HH:mm:ss'),
    // value: !value || value == []? [null,null]: [moment(value[0],(format || (!showTime?'YYYY-MM-DD':'YYYY-MM-DD HH:mm:ss'))),moment(value[1],(format || (!showTime?'YYYY-MM-DD':'YYYY-MM-DD HH:mm:ss')))],
    value: !value ? [null, null] : [value[0] ? (0, _moment["default"])(value[0], format || (!showTime ? 'YYYY-MM-DD' : 'YYYY-MM-DD HH:mm:ss')) : null, value[1] ? (0, _moment["default"])(value[1], format || (!showTime ? 'YYYY-MM-DD' : 'YYYY-MM-DD HH:mm:ss')) : null],
    style: style || {},
    placeholder: placeholder ? [placeholder, placeholder] : ['请选择时间', '请选择时间'],
    size: size || 'default',
    onChange: function onChange(date, dateString) {
      if (date[0] && date[1]) {
        //防止,时间和日期之间切换选择后,前大后小的bug
        var d1 = date[0],
            d2 = date[1],
            ds1 = dateString[0],
            ds2 = dateString[1];
        var d = [],
            ds = [];

        if (d1.valueOf() <= d2.valueOf()) {
          d = [d1, d2];
          ds = [ds1, ds2];
        } else {
          d = [d2, d1];
          ds = [ds2, ds1];
        }

        _onChange(d, ds);
      } else {
        _onChange(date, dateString);
      }
    },
    onOpenChange: onOpenChange,
    disabledTime: disabledTime,
    onOk: onOk
  });

  if ('open' in props) {
    DatePickerProps.open = open;
  }

  if ('disabledDate' in props) {
    if (typeof disabledDate === 'function') {
      DatePickerProps.disabledDate = disabledDate;
    } // DatePickerProps.disabledDate = disabledDateFun;

  }

  if (required && (!value || !value[0] && !value[1])) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: cm_style.error,
      "data-errorMsg": "\u5FC5\u586B"
    }, /*#__PURE__*/_react["default"].createElement(RangePicker, DatePickerProps));
  } else {
    return /*#__PURE__*/_react["default"].createElement(RangePicker, DatePickerProps);
  }
}

var _default = VtxRangePicker;
exports["default"] = _default;
module.exports = exports["default"];
//# sourceMappingURL=VtxRangePicker.js.map
