"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _moment = _interopRequireDefault(require("moment"));

require("moment/locale/zh-cn");

var _timePicker = _interopRequireDefault(require("antd/lib/time-picker"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

_moment["default"].locale('zh-cn');

var cm_style = {
  error: 'vtx-ui-date-error'
};

function VtxTimePicker(props) {
  var value = props.value,
      className = props.className,
      popupClassName = props.popupClassName,
      open = props.open,
      format = props.format,
      disabled = props.disabled,
      hideDisabledOptions = props.hideDisabledOptions,
      placeholder = props.placeholder,
      required = props.required,
      onOpenChange = props.onOpenChange,
      onChange = props.onChange,
      disabledHours = props.disabledHours,
      disabledMinutes = props.disabledMinutes,
      disabledSeconds = props.disabledSeconds,
      addon = props.addon;

  var TimePickerProps = _objectSpread(_objectSpread({}, props), {}, {
    value: value ? (0, _moment["default"])(value, format || 'HH:mm:ss') : null,
    className: className,
    popupClassName: popupClassName,
    disabled: disabled || false,
    hideDisabledOptions: hideDisabledOptions || false,
    format: format || 'HH:mm:ss',
    placeholder: placeholder || '请选择时间',
    onChange: onChange,
    onOpenChange: onOpenChange,
    disabledHours: disabledHours,
    disabledMinutes: disabledMinutes,
    disabledSeconds: disabledSeconds,
    addon: addon,
    style: props.style
  });

  if ('open' in props) {
    TimePickerProps.open = open;
  }

  if (required && !value) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: cm_style.error,
      "data-errorMsg": "\u5FC5\u586B"
    }, /*#__PURE__*/_react["default"].createElement(_timePicker["default"], TimePickerProps));
  } else {
    return /*#__PURE__*/_react["default"].createElement(_timePicker["default"], TimePickerProps);
  }
}

var _default = VtxTimePicker;
exports["default"] = _default;
module.exports = exports["default"];
//# sourceMappingURL=VtxTimePicker.js.map
