"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _VtxYearPicker_t = _interopRequireDefault(require("./VtxYearPicker_t"));

var _moment = _interopRequireDefault(require("moment"));

require("moment/locale/zh-cn");

var _icon = _interopRequireDefault(require("antd/lib/icon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

_moment["default"].locale('zh-cn');

var styles = {
  normal: 'vtx-ui-date-normal',
  calendarpicker: 'vtx-ui-date-calendarpicker',
  clearDate: 'vtx-ui-date-cleardate',
  calendarpickerinput: 'vtx-ui-date-calendarpickerinput',
  calendaricon: 'vtx-ui-date-calendaricon',
  error: 'vtx-ui-date-error',
  years: 'vtx-ui-date-years',
  yearsTitle: 'vtx-ui-date-yearstitle',
  arrows: 'vtx-ui-date-arrows',
  lists: 'vtx-ui-date-lists',
  list: 'vtx-ui-date-list',
  selectlist: 'vtx-ui-date-selectlist',
  selectlist_disabled: 'vtx-ui-date-selectlist_disabled',
  noselect: 'vtx-ui-date-noselect',
  hidden: 'vtx-ui-date-hidden',
  show: 'vtx-ui-date-show'
};

var VtxYearPicker = /*#__PURE__*/function (_React$Component) {
  _inherits(VtxYearPicker, _React$Component);

  var _super = _createSuper(VtxYearPicker);

  function VtxYearPicker(props) {
    var _this;

    _classCallCheck(this, VtxYearPicker);

    _this = _super.call(this, props);
    _this.state = {
      sizeStyle: {
        small: {
          padding: '1px 7px',
          height: '22px'
        },
        "default": {
          padding: '4px 7px',
          height: '28px'
        },
        large: {
          padding: '6px 7px',
          height: '32px'
        }
      },
      nowTime: props.value ? (0, _moment["default"])(props.value, 'YYYY').format('YYYY') : (0, _moment["default"])().format('YYYY'),
      dom: null,
      sign: 0,
      open: props.open
    };
    return _this;
  }

  _createClass(VtxYearPicker, [{
    key: "getLocation",
    value: function getLocation(e) {
      var t = this;
      var bodyTop = 0,
          bodyLeft = 0,
          allHeight = 0,
          inputHeight = 0,
          bottom = 0,
          signtype = 't'; //获取滚动距离

      if (document.documentElement && document.documentElement.scrollTop) {
        bodyTop = document.documentElement.scrollTop;
        bodyLeft = document.documentElement.scrollLeft;
      } else if (document.body) {
        bodyTop = document.body.scrollTop;
        bodyLeft = document.body.scrollLeft;
      } //可视区域高度


      if (document.documentElement) {
        allHeight = document.documentElement.clientHeight;
      } //计算top和left值


      var left = e.getBoundingClientRect().left + bodyLeft - 2;
      var top = e.getBoundingClientRect().top + bodyTop; //判断在上还是在下

      if (allHeight - top + bodyTop < 270) {
        switch (t.props.size) {
          case 'small':
            inputHeight = 22;
            break;

          case 'default':
            inputHeight = 28;
            break;

          case 'large':
            inputHeight = 32;
            break;

          default:
            inputHeight = 28;
            break;
        }

        signtype = 'b';
        top = top - 250 + inputHeight;
        bottom = top + 254;
      }

      top = top - 4;
      return {
        top: top,
        left: left,
        bottom: bottom,
        signtype: signtype
      };
    }
  }, {
    key: "renderDOM",
    value: function renderDOM(time, e) {
      var t = this;

      if (!t.props.disabled) {
        // e.nativeEvent.stopImmediatePropagation();
        //input失去焦点
        e.target.parentNode.childNodes[0].blur();
        var tm = time || t.state.nowTime; //如不存dom的时候就添加一个,如果已经存在就跳过

        if (!t.state.dom) {
          var d = document.createElement('div');
          d.style.position = 'absolute';
          d.style.top = '0px';
          d.style.left = '0px';
          d.style.width = '100%';
          t.state.dom = document.body.appendChild(d);
        }

        var _t$getLocation = t.getLocation(e.target.parentNode.childNodes[0]),
            top = _t$getLocation.top,
            left = _t$getLocation.left,
            bottom = _t$getLocation.bottom,
            signtype = _t$getLocation.signtype;

        if (_moment["default"].isMoment(tm)) {
          tm = (0, _moment["default"])(tm).format('YYYY');
        }

        var param = {
          style: styles.show,
          time: tm
        };

        if ('open' in t.props) {
          param.open = t.props.open;

          if (t.props.open) {
            param.style = styles.show;
            param.time = tm;
          } else {
            param.style = styles.hidden;
          }
        }

        _reactDom["default"].render( /*#__PURE__*/_react["default"].createElement(_VtxYearPicker_t["default"], _extends({
          sign: t.state.sign++,
          top: top,
          left: left,
          bottom: bottom,
          signtype: signtype,
          onChange: t.props.onChange,
          disabledDate: t.props.disabledDate
        }, param)), t.state.dom);
      }
    }
  }, {
    key: "clearTime",
    value: function clearTime(e) {
      e.nativeEvent.stopImmediatePropagation();
      var t = this;

      if ('onChange' in t.props) {
        t.props.onChange('', '');
      }
    }
  }, {
    key: "render",
    value: function render() {
      var t = this;
      var props = t.props;
      return /*#__PURE__*/_react["default"].createElement("div", {
        "data-errorMsg": "\u5FC5\u586B",
        className: props.required && !props.value ? "".concat(styles.normal, " ").concat(styles.error) : styles.normal,
        style: _objectSpread(_objectSpread({}, props.style), {}, {
          width: props.inherit ? 'inherit' : ''
        })
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(styles.calendarpicker, " ").concat(props.className),
        style: props.style
      }, /*#__PURE__*/_react["default"].createElement("input", {
        ref: 'input',
        readOnly: true,
        type: "text",
        disabled: props.disabled,
        placeholder: props.placeholder || '请选择时间',
        className: styles.calendarpickerinput,
        style: t.state.sizeStyle[props.size || 'default'],
        value: props.value ? (0, _moment["default"])(props.value, 'YYYY').format('YYYY') : '',
        onClick: function onClick(e) {
          return t.renderDOM('', e);
        }
      }), /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        type: "calendar",
        className: styles.calendaricon,
        onClick: function onClick(e) {
          return t.renderDOM('', e);
        }
      }), props.allowClear ? /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        type: "close-circle",
        className: styles.clearDate,
        onClick: function onClick(e) {
          t.clearTime(e);
        }
      }) : ''));
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      //插入真实DOM结束
      var t = this;

      if ('open' in t.props && t.props.open) {
        t.refs.input.click();
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      //已加载组件，收到新的参数时调用
      var t = this;
      t.setState({
        nowTime: nextProps.value || (0, _moment["default"])().format('YYYY')
      });
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      //重新渲染结束
      var t = this;

      if ('open' in t.props) {
        t.refs.input.click();
      }
    }
  }]);

  return VtxYearPicker;
}(_react["default"].Component); //large 高度为 32px，small 为 22px，default是 28px


var _default = VtxYearPicker;
exports["default"] = _default;
module.exports = exports["default"];
//# sourceMappingURL=VtxYearPicker.js.map
