"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _VtxImageViewer = _interopRequireDefault(require("../VtxImageViewer"));

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var defaultEmptyImageSrc = '';
var defaultErrorImageSrc = '';
var defaultEmptyText = '暂无图片';
var defaultErrorText = '图片出错';

var ImageCustom = /*#__PURE__*/function (_React$Component) {
  _inherits(ImageCustom, _React$Component);

  var _super = _createSuper(ImageCustom);

  function ImageCustom(props) {
    var _this;

    _classCallCheck(this, ImageCustom);

    _this = _super.call(this, props);
    _this.state = {
      loadError: false,
      // 图片是否加载失败
      emptyError: false,
      // 空白图片是否加载失败
      errorError: false,
      // 报错图片是否加载失败
      viewerVisible: false // 是否查看

    };
    _this.emptyImageSrc = props.emptyImageSrc || defaultEmptyImageSrc;
    _this.errorImageSrc = props.errorImageSrc || defaultErrorImageSrc; // 缩略图

    _this.hasThumb = !!props.thumb;
    _this.renderImgNode = _this.renderImgNode.bind(_assertThisInitialized(_this));
    _this.onImgClick = _this.onImgClick.bind(_assertThisInitialized(_this));
    _this.renderImageViewer = _this.renderImageViewer.bind(_assertThisInitialized(_this));
    _this.onViewerClose = _this.onViewerClose.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(ImageCustom, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var nextSrc = nextProps.src;

      if (!(0, _isEqual["default"])(this.props.src, nextSrc)) {
        this.setState({
          loadError: false
        });
      }
    } // 图片点击

  }, {
    key: "onImgClick",
    value: function onImgClick() {
      this.setState({
        viewerVisible: true
      }); // 回调

      if (typeof this.props.onClick == 'function') {
        this.props.onClick();
      }
    } // 关闭画廊

  }, {
    key: "onViewerClose",
    value: function onViewerClose() {
      this.setState({
        viewerVisible: false
      });
    } // 查看

  }, {
    key: "renderImageViewer",
    value: function renderImageViewer(_ref) {
      var allowView = _ref.allowView,
          viewer = _ref.viewer;

      if (!allowView) {
        return null;
      }

      var _this$props = this.props,
          src = _this$props.src,
          title = _this$props.title,
          alt = _this$props.alt;

      var _getComponentProps = (0, _util.getComponentProps)(viewer),
          photo = _getComponentProps.photo;

      var newPhoto = photo; // 若未配置photo，则默认使用Iamge src展示

      if (!photo) {
        newPhoto = {
          id: src,
          name: title || alt
        };
      }

      return /*#__PURE__*/_react["default"].createElement(_VtxImageViewer["default"], _extends({
        photo: newPhoto
      }, viewer, {
        visible: this.state.viewerVisible,
        onClose: this.onViewerClose
      }));
    }
  }, {
    key: "renderImgNode",
    value: function renderImgNode() {
      var _this2 = this;

      var _this$props2 = this.props,
          prefixCls = _this$props2.prefixCls,
          thumb = _this$props2.thumb,
          className = _this$props2.className,
          style = _this$props2.style,
          alt = _this$props2.alt,
          src = _this$props2.src,
          _this$props2$emptyTex = _this$props2.emptyText,
          emptyText = _this$props2$emptyTex === void 0 ? defaultEmptyText : _this$props2$emptyTex,
          _this$props2$errorTex = _this$props2.errorText,
          errorText = _this$props2$errorTex === void 0 ? defaultErrorText : _this$props2$errorTex,
          onClick = _this$props2.onClick;
      var imgProps = {
        src: src,
        className: className,
        style: style,
        alt: alt,
        onClick: onClick
      }; // 无图片

      if (!src) {
        //有替代图片
        if (this.emptyImageSrc && !this.state.emptyError) {
          imgProps.src = this.emptyImageSrc;

          imgProps.onError = function () {
            _this2.setState({
              emptyError: true
            });
          };
        } else {
          // 没有替代图片或替代图片无法加载
          return /*#__PURE__*/_react["default"].createElement("div", {
            className: "".concat(prefixCls, "-nodata"),
            style: style
          }, /*#__PURE__*/_react["default"].createElement("p", null, emptyText));
        }
      } // 无法加载图片时记录图片地址方便跟踪


      if (this.state.loadError) {
        // 加载报错图片
        if (this.errorImageSrc && !this.state.errorError) {
          imgProps['data-error-img'] = src;
          imgProps.src = this.errorImageSrc;

          imgProps.onError = function () {
            _this2.setState({
              errorError: true
            });
          };
        } else {
          // 无法加载报错图片
          return /*#__PURE__*/_react["default"].createElement("div", {
            className: "".concat(prefixCls, "-error"),
            style: style,
            "data-error-img": src
          }, /*#__PURE__*/_react["default"].createElement("p", null, errorText));
        }
      } else {
        imgProps.onError = function () {
          _this2.setState({
            loadError: true
          });
        };
      } // 缩略图模式 | 此模式下支持放大查看


      if (this.hasThumb) {
        var _getComponentProps2 = (0, _util.getComponentProps)(thumb),
            backgroundColor = _getComponentProps2.backgroundColor,
            _getComponentProps2$a = _getComponentProps2.allowView,
            allowView = _getComponentProps2$a === void 0 ? false : _getComponentProps2$a,
            _getComponentProps2$v = _getComponentProps2.viewer,
            viewer = _getComponentProps2$v === void 0 ? {} : _getComponentProps2$v; // class


        var thumbCls = (0, _classnames2["default"])("".concat(prefixCls, "-thumb"), _defineProperty({}, "".concat(prefixCls, "-view"), allowView)); // 允许查看

        if (allowView) {
          imgProps.onClick = this.onImgClick;
        }

        return /*#__PURE__*/_react["default"].createElement("div", {
          className: thumbCls,
          style: backgroundColor ? {
            backgroundColor: backgroundColor
          } : null
        }, /*#__PURE__*/_react["default"].createElement("img", imgProps), this.renderImageViewer({
          allowView: allowView,
          viewer: viewer
        }));
      }

      return /*#__PURE__*/_react["default"].createElement("img", imgProps);
    }
  }, {
    key: "render",
    value: function render() {
      return this.renderImgNode();
    }
  }]);

  return ImageCustom;
}(_react["default"].Component);

_defineProperty(ImageCustom, "defaultProps", {
  prefixCls: 'vtx-image',
  thumb: false // 缩略图模式

});

function setImageConfig(options) {
  var emptyImageSrc = options.emptyImageSrc,
      errorImageSrc = options.errorImageSrc,
      emptyText = options.emptyText,
      errorText = options.errorText;

  if (emptyImageSrc !== undefined) {
    defaultEmptyImageSrc = emptyImageSrc;
  }

  if (errorImageSrc !== undefined) {
    defaultErrorImageSrc = errorImageSrc;
  }

  if (emptyText !== undefined) {
    defaultEmptyText = emptyText;
  }

  if (errorText !== undefined) {
    defaultErrorText = errorText;
  }
}

ImageCustom.config = setImageConfig;
var _default = ImageCustom;
exports["default"] = _default;
module.exports = exports["default"];
//# sourceMappingURL=index.js.map
