"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _viewerjs = _interopRequireDefault(require("viewerjs"));

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));

var _internal = require("./-internal");

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var ImageViewer = /*#__PURE__*/function (_React$Component) {
  _inherits(ImageViewer, _React$Component);

  var _super = _createSuper(ImageViewer);

  /**
   * props
   * visible {[Boolean]}  [是否显示]
   * photo   {[Object || Array]}  [图片]  {id: '', name: ''} || [{id: '', name: ''}]
   * index   {[Number]} photo [图片下标 用于多张图片展示，从 0 开始] 
   * options {[Object]} [viewerjs 配置项]
   */
  function ImageViewer(props) {
    var _this;

    _classCallCheck(this, ImageViewer);

    _this = _super.call(this, props);
    _this.state = {}; // 选项
    // 详细参考 https://github.com/fengyuanchen/viewerjs#options

    _this.options = _objectSpread({
      button: true,
      // 显示右上角关闭按钮
      navbar: false,
      // 显示缩略图导航
      title: true,
      // 显示当前图片的标题（现实 alt 属性及图片尺寸）
      toolbar: true,
      // 是否显示工具栏 
      tooltip: true,
      // 显示缩放百分比
      movable: true,
      // 图片是否可移动
      zoomable: true,
      // 图片是否可缩放
      rotatable: true,
      // 图片是否可旋转
      scalable: true,
      // 图片是否可翻转
      transition: true
    }, props.options);
    _this.view = _this.view.bind(_assertThisInitialized(_this));
    _this.container = document.createElement('div');
    _this.viewer = new _viewerjs["default"](_this.container, _objectSpread({
      // 关闭后
      hidden: function hidden() {
        if ('onClose' in props && (0, _util.isFunction)(props.onClose)) {
          props.onClose();
        }
      },
      view: function view(e) {
        if ('onIndexChange' in props && (0, _util.isFunction)(props.onIndexChange)) {
          // 图片下标变更
          props.onIndexChange(e.detail.index);
        }
      }
    }, _this.options));
    return _this;
  }

  _createClass(ImageViewer, [{
    key: "componentWillUpdate",
    value: function componentWillUpdate(nextProps, nextState) {
      // visible 为true时
      if (nextProps.visible && !(0, _isEqual["default"])(this.props.visible, nextProps.visible)) {
        this.view(nextProps);
      }
    }
  }, {
    key: "view",
    value: function view(props) {
      var _t = this; // 若容器中已存在子元素，则清空


      if (this.container.childNodes.length > 0) {
        this.container.innerHTML = '';
      }

      var _props$photo = props.photo,
          photo = _props$photo === void 0 ? {} : _props$photo,
          _props$index = props.index,
          index = _props$index === void 0 ? 0 : _props$index;
      var mode = (0, _internal.checkMode)(photo);
      var newPhoto = (0, _cloneDeep["default"])(photo); // 单张

      if (mode === _internal.VIEWER) {
        index = 0;
        newPhoto = (0, _util.isObject)(newPhoto) ? newPhoto : newPhoto[0];
        var imgElem = document.createElement('img');
        imgElem.src = newPhoto.id;
        imgElem.alt = newPhoto.name;
        this.container.appendChild(imgElem);
      } // 多张


      if (mode === _internal.GALLERY) {
        var len = newPhoto.length - 1;
        index = index < 0 ? 0 : index;
        index = index > len ? len : index;
        var ulElem = document.createElement('ul');
        newPhoto.map(function (item) {
          var liElem = document.createElement('li');
          var imgElem = document.createElement('img');
          imgElem.src = item.id;
          imgElem.alt = item.name;
          liElem.appendChild(imgElem);
          ulElem.appendChild(liElem);
        });
        this.container.appendChild(ulElem);
      }

      this.viewer.update();
      this.viewer.view(index);
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      // 销毁
      this.viewer && this.viewer.destroy();
    }
  }]);

  return ImageViewer;
}(_react["default"].Component);

var _default = ImageViewer;
exports["default"] = _default;
module.exports = exports["default"];
//# sourceMappingURL=index.js.map
