"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _Map = _interopRequireDefault(require("./Map"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var OptimizingPointMap = /*#__PURE__*/function (_React$Component) {
  _inherits(OptimizingPointMap, _React$Component);

  var _super = _createSuper(OptimizingPointMap);

  function OptimizingPointMap(props) {
    var _this;

    _classCallCheck(this, OptimizingPointMap);

    _this = _super.call(this, props);
    _this.map = null;
    _this.mapLoaded = false;
    _this.MPP = new mapPointsProcessor(props.gridSpacing || 40);
    _this.state = {
      filterPoints: []
    };
    _this.zoomEnd = _this.zoomEnd.bind(_assertThisInitialized(_this));
    _this.moveEnd = _this.moveEnd.bind(_assertThisInitialized(_this));
    _this.resetPoints = _this.resetPoints.bind(_assertThisInitialized(_this));
    _this.resetDelay = {
      timer: null,
      eType: null
    };
    return _this;
  }

  _createClass(OptimizingPointMap, [{
    key: "resetPoints",
    value: function resetPoints(props, eType) {
      var t = this; // 延时优化，只处理最后一次操作

      if (t.resetDelay.timer) {
        clearTimeout(t.resetDelay.timer);
      }

      t.resetDelay.eType = t.resetDelay.eType == 'zoom' || eType == 'zoom' ? 'zoom' : eType;
      t.resetDelay.timer = setTimeout(function () {
        var mcfg = t.map.getMapExtent();
        var param = {
          mapHeight: mcfg.mapSize.height,
          mapWidth: mcfg.mapSize.width,
          minLat: mcfg.southWest.lat,
          maxLat: mcfg.northEast.lat,
          minLng: mcfg.southWest.lng,
          maxLng: mcfg.northEast.lng,
          eType: t.resetDelay.eType,
          allPoints: props.mapPoints,
          reservedPoints: props.reservedPoints
        };
        t.setState({
          filterPoints: t.MPP.pointFilter(param)
        });
        t.resetDelay.timer = null;
        t.resetDelay.eType = null;
      }, 200);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.map.loadMapComplete.then(function () {
        _this2.resetPoints(_this2.props);

        _this2.mapLoaded = true;
      });
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (this.mapLoaded && (!(0, _isEqual2["default"])(this.props.reservedPoints, nextProps.reservedPoints) || !(0, _isEqual2["default"])(this.props.mapPoints, nextProps.mapPoints))) {
        // 外部点数据改变，更新内部点数据
        this.resetPoints(nextProps);
      }
    }
  }, {
    key: "zoomEnd",
    value: function zoomEnd(obj) {
      this.resetPoints(this.props, 'zoom');

      if (typeof this.props.zoomEnd === "function") {
        this.props.zoomEnd(obj);
      }
    }
  }, {
    key: "moveEnd",
    value: function moveEnd(obj) {
      this.resetPoints(this.props, 'move');

      if (typeof this.props.moveEnd === "function") {
        this.props.moveEnd(obj);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      // console.log('优化后剩余点数：'+this.state.filterPoints.length)  
      var newProps = _objectSpread(_objectSpread({}, this.props), {}, {
        zoomEnd: this.zoomEnd,
        moveEnd: this.moveEnd,
        mapPoints: this.state.filterPoints,
        getMapInstance: function getMapInstance(p) {
          if (p) {
            _this3.map = p;
          }

          if (typeof _this3.props.getMapInstance === "function") {
            _this3.props.getMapInstance(p);
          }
        }
      });

      delete newProps.gridSpacing;
      delete newProps.reservedPoints;
      return /*#__PURE__*/_react["default"].createElement(_Map["default"], newProps);
    }
  }]);

  return OptimizingPointMap;
}(_react["default"].Component);

var mapPointsProcessor = /*#__PURE__*/function () {
  function mapPointsProcessor(gridSpacing) {
    _classCallCheck(this, mapPointsProcessor);

    this.GRIDSPACING = gridSpacing || 40;
    this.mapHeight = null; //地图高度

    this.mapWidth = null; //地图宽度
    // 若地图大小不变，zoom不变，网格的经纬度间隔应该保持不变以保证前后两次网格位置保持一致

    this.lngInterval = null; //划分的网格经度间隔

    this.latInterval = null; //划分的网格纬度间隔

    this.maxLat = null, this.minLat = null, this.maxLng = null, this.minLng = null;
  }

  _createClass(mapPointsProcessor, [{
    key: "resetMapConfig",
    value: function resetMapConfig(param) {
      // 若没传地图相关参数默认使用上次的地图参数
      var mapHeight = param.mapHeight,
          mapWidth = param.mapWidth,
          maxLat = param.maxLat,
          minLat = param.minLat,
          maxLng = param.maxLng,
          minLng = param.minLng,
          eType = param.eType;
      this.maxLat = maxLat || this.maxLat;
      this.minLat = minLat || this.minLat;
      this.maxLng = maxLng || this.maxLng;
      this.minLng = minLng || this.minLng; // 当操作为zoom（改变最大最小经纬度）或地图宽高改变则重新计算网格

      if (eType == 'zoom' || mapHeight && mapHeight != this.mapHeight || mapWidth && mapWidth != this.mapWidth) {
        this.mapHeight = mapHeight || this.mapHeight;
        this.mapWidth = mapWidth || this.mapWidth;
        this.calGridInterval();
      }
    }
  }, {
    key: "calGridInterval",
    value: function calGridInterval() {
      var x_num = Math.ceil(this.mapWidth / this.GRIDSPACING);
      var y_num = Math.ceil(this.mapHeight / this.GRIDSPACING);
      this.lngInterval = parseFloat(((this.maxLng - this.minLng) / x_num).toFixed(6));
      this.latInterval = parseFloat(((this.maxLat - this.minLat) / y_num).toFixed(6));
    }
  }, {
    key: "pointFilter",
    value: function pointFilter(param) {
      // allPoints为必填参数
      var allPoints = param.allPoints,
          _param$reservedPoints = param.reservedPoints,
          reservedPoints = _param$reservedPoints === void 0 ? [] : _param$reservedPoints;
      this.resetMapConfig(param);
      var hashPoints = {};

      for (var i = 0, len = allPoints.length; i < len; i++) {
        var p_lng = allPoints[i].longitude;
        var p_lat = allPoints[i].latitude;

        if (p_lng > this.maxLng || p_lng < this.minLng || p_lat > this.maxLat || p_lat < this.minLat) {
          continue;
        }

        var x_index = parseInt(p_lng / this.lngInterval);
        var y_index = parseInt(p_lat / this.latInterval);
        var hashIndex = x_index + '-' + y_index;

        if (!hashPoints[hashIndex]) {
          hashPoints[hashIndex] = allPoints[i];
        }
      }

      var filteredPoints = _toConsumableArray(reservedPoints);

      var reservedIds = reservedPoints.map(function (item) {
        return item.id;
      });

      for (var k in hashPoints) {
        var the_point = hashPoints[k];

        if (reservedIds.indexOf(the_point.id) == -1) {
          filteredPoints.push(the_point);
        }
      }

      return filteredPoints;
    }
  }]);

  return mapPointsProcessor;
}();

var _default = OptimizingPointMap;
exports["default"] = _default;
module.exports = exports["default"];
//# sourceMappingURL=optimizingPointMap.js.map
