"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _Map = _interopRequireDefault(require("./Map"));

var _immutable = _interopRequireDefault(require("immutable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var zoomMap = /*#__PURE__*/function (_React$Component) {
  _inherits(zoomMap, _React$Component);

  var _super = _createSuper(zoomMap);

  function zoomMap(props) {
    var _this;

    _classCallCheck(this, zoomMap);

    _this = _super.call(this, props);
    _this.map = null;
    _this.state = {
      filterPoints: []
    };
    return _this;
  }

  _createClass(zoomMap, [{
    key: "resetPoints",
    value: function resetPoints() {
      var mapPoints = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var zoomLv = arguments.length > 1 ? arguments[1] : undefined;
      // console.log('当前zoom等级',this.state.zoomLv);
      console.log(this.map.getMapExtent());
      zoomLv = zoomLv || this.map.getZoomLevel();

      if (zoomLv) {
        this.setState({
          filterPoints: mapPoints.filter(function (item) {
            return typeof item.zoomLevel == 'number' ? item.zoomLevel <= zoomLv : true;
          })
        }, function () {// console.log(`zoom等级(${this.state.zoomLv})过滤后还有${this.state.filterPoints.length}个点`);
        });
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      // console.log(this.map.getMapExtent())        
      // 地图加载完成取得当前zoom值，初始化内部点数据
      this.resetPoints(this.props.mapPoints);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (!this.deepEqual(this.props.mapPoints, nextProps.mapPoints)) {
        // 外部点数据改变，更新内部点数据
        this.resetPoints(nextProps.mapPoints);
      }
    }
  }, {
    key: "deepEqual",
    value: function deepEqual(a, b) {
      return _immutable["default"].is(_immutable["default"].fromJS(a), _immutable["default"].fromJS(b));
    }
  }, {
    key: "zoomEnd",
    value: function zoomEnd(obj) {
      // console.log(obj)
      //zoom操作后，更新内部点数据
      this.resetPoints(this.props.mapPoints);

      if (typeof this.props.zoomEnd === "function") {
        this.props.zoomEnd(obj);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var newProps = _objectSpread(_objectSpread({}, this.props), {}, {
        zoomEnd: this.zoomEnd.bind(this),
        mapPoints: this.state.filterPoints,
        ref: function ref(p) {
          if (p) {
            _this2.map = p;
          }
        }
      }); // 屏蔽地图默认的setFitView的调整zoom功能，只会重新设置center


      if (newProps.mapVisiblePoints) {
        newProps.mapVisiblePoints = _objectSpread(_objectSpread({}, newProps.mapVisiblePoints), {}, {
          type: 'center'
        });
      }

      return /*#__PURE__*/_react["default"].createElement(_Map["default"], newProps);
    }
  }]);

  return zoomMap;
}(_react["default"].Component);

var _default = zoomMap;
exports["default"] = _default;
module.exports = exports["default"];
//# sourceMappingURL=zoomMap.js.map
