"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _modal = _interopRequireDefault(require("antd/lib/modal"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var DraggableModal = /*#__PURE__*/function (_React$Component) {
  _inherits(DraggableModal, _React$Component);

  var _super = _createSuper(DraggableModal);

  function DraggableModal(props) {
    var _this;

    _classCallCheck(this, DraggableModal);

    _this = _super.call(this, props);
    _this.state = {
      init_x: 0,
      init_y: 0,
      x_move: 0,
      y_move: 0
    };
    _this.initSucceed = false; //是否已完成初始化拖拽事件

    _this.startDrag = _this.startDrag.bind(_assertThisInitialized(_this));
    _this.initEvent = _this.initEvent.bind(_assertThisInitialized(_this));
    return _this;
  } // 初始化弹框的拖拽事件


  _createClass(DraggableModal, [{
    key: "initEvent",
    value: function initEvent() {
      if (!this.drag) return;

      var modalHead = _reactDom["default"].findDOMNode(this.drag).parentNode.previousSibling;

      if (modalHead.className.indexOf('ant-modal-header') !== -1) {
        modalHead.style.cursor = 'move';
        modalHead.onmousedown = this.startDrag;
        this.initSucceed = true;
      }
    } // 开始拖拽：绑定事件

  }, {
    key: "startDrag",
    value: function startDrag(e) {
      var _this2 = this;

      e.preventDefault();
      this.setState({
        init_x: e.clientX - this.state.x_move,
        init_y: e.clientY - this.state.y_move
      });

      var mousemove = function mousemove(e) {
        _this2.setState({
          x_move: e.clientX - _this2.state.init_x,
          y_move: e.clientY - _this2.state.init_y
        });
      };

      var mouseup = function mouseup(e) {
        document.removeEventListener('mousemove', mousemove);
        document.removeEventListener('mouseup', mouseup);
      };

      document.addEventListener('mousemove', mousemove);
      document.addEventListener('mouseup', mouseup);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var transformStyle = {
        transform: "translate(".concat(this.state.x_move, "px,").concat(this.state.y_move, "px)")
      };

      var props = _objectSpread(_objectSpread({}, this.props), {}, {
        style: _objectSpread(_objectSpread({}, this.props.style), transformStyle)
      });

      return /*#__PURE__*/_react["default"].createElement(_modal["default"], props, this.props.children, /*#__PURE__*/_react["default"].createElement("div", {
        ref: function ref(elem) {
          _this3.drag = elem;
        }
      }));
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.initEvent();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      if (!this.initSucceed) {
        this.initEvent();
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (!this.props.visible && nextProps.visible && !nextProps.remainPosition) {
        this.setState({
          init_x: 0,
          init_y: 0,
          x_move: 0,
          y_move: 0
        });
      }
    }
  }]);

  return DraggableModal;
}(_react["default"].Component);

var _default = DraggableModal;
exports["default"] = _default;
module.exports = exports["default"];
//# sourceMappingURL=draggableModal.js.map
