"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  iframeParent: 'vtx-ui-frame-ct'
};

function getUrlParam(key) {
  var paramObj = {};
  var matchList = window.location.href.match(/([^\?&]+)=([^&]+)/g) || [];

  for (var i = 0, len = matchList.length; i < len; i++) {
    var r = matchList[i].match(/([^\?&]+)=([^&]+)/);
    paramObj[r[1]] = r[2];
  }

  if (key) {
    return paramObj[key];
  } else {
    return paramObj;
  }
}

var getSystemInfo = function getSystemInfo(key) {
  var systemInfo = localStorage.getItem('systemInfo');
  var system = {};

  if (systemInfo) {
    system = JSON.parse(decodeURIComponent(decodeURIComponent(systemInfo)));
    system = _objectSpread(_objectSpread({}, system), {}, {
      access_token: system.token
    });
  }

  if (key) {
    return system[key];
  }
};

var getToken = function getToken() {
  var token = getSystemInfo('token') || getSystemInfo('access_token') || localStorage.getItem('token') || localStorage.getItem('access_token') || sessionStorage.getItem('token') || sessionStorage.getItem('access_token') || getUrlParam('token') || getUrlParam('access_token');
  return token;
};

var VtxRpsFrame = /*#__PURE__*/function (_React$Component) {
  _inherits(VtxRpsFrame, _React$Component);

  var _super = _createSuper(VtxRpsFrame);

  function VtxRpsFrame() {
    var _this;

    _classCallCheck(this, VtxRpsFrame);

    _this = _super.call(this);
    _this.iframeName = Math.random() + new Date().getTime();
    return _this;
  }

  _createClass(VtxRpsFrame, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      if (this.props.flag !== nextProps.flag) {
        return true;
      } else {
        return false;
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.getReportInfoByCode();
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.getReportInfoByCode();
    }
  }, {
    key: "getReportInfoByCode",
    value: function getReportInfoByCode() {
      var t = this;
      var _this$props = this.props,
          report_code = _this$props.report_code,
          report_param = _this$props.report_param,
          data_param = _this$props.data_param,
          paramTypeCode = _this$props.paramTypeCode,
          tenantId = _this$props.tenantId,
          _this$props$getTypeCo = _this$props.getTypeCodeUrl,
          getTypeCodeUrl = _this$props$getTypeCo === void 0 ? '/cloud/management/rest/np/param/getByParamTypeCode' : _this$props$getTypeCo,
          _this$props$getReport = _this$props.getReportCodeUrl,
          getReportCodeUrl = _this$props$getReport === void 0 ? '/cloud/rps/api/np/v101/report/getReportInfoByCode.smvc' : _this$props$getReport,
          _this$props$ReportSer = _this$props.ReportServerUrl,
          ReportServerUrl = _this$props$ReportSer === void 0 ? '/ReportServer' : _this$props$ReportSer;
      var token = getToken('');
      var param = {
        report_code: report_code,
        timestamp: new Date().valueOf(),
        reqMethod: 0
      };
      var paramCode = paramTypeCode || "param_report_constant"; //获取公共参数

      var commonParamPromise = new Promise(function (resolve, reject) {
        $.ajax({
          type: 'get',
          url: "".concat(getTypeCodeUrl, "?parameters={\"paramTypeCode\": \"").concat(paramCode, "\",\"tenantId\":\"").concat(tenantId, "\"}"),
          // data: postData,
          dataType: 'json',
          'content-type': "application/x-www-form-urlencoded",
          headers: {
            'Authorization': token ? "Bearer ".concat(token) : ''
          },
          cache: false,
          success: function success(data) {
            resolve(data);
          },
          error: function error(XMLHttpRequest, textStatus, errorThrown) {
            reject(textStatus);
          }
        });
      }); //获取报表code

      var getReportInfoByCodePromise = new Promise(function (resolve, reject) {
        $.ajax({
          type: 'get',
          url: getReportCodeUrl,
          headers: {
            'Authorization': token ? "Bearer ".concat(token) : ''
          },
          data: {
            parameters: JSON.stringify(param)
          },
          dataType: 'json',
          async: true,
          success: function success(data) {
            resolve(data);
          },
          error: function error(XMLHttpRequest, textStatus, errorThrown) {
            reject(textStatus);
          }
        });
      });
      Promise.all([commonParamPromise, getReportInfoByCodePromise]).then(function (data) {
        var commonParamResult = data[0];
        var reportInfoByCodeResult = data[1];

        if (!commonParamResult.result && !reportInfoByCodeResult.result) {
          //报表公共参数
          var commonParamData = commonParamResult.data;
          var obj = {};
          commonParamData.forEach(function (d) {
            obj[d.parmCode] = d.parmName;
          });
          var reportInfoByCodeData = reportInfoByCodeResult.data;

          var _param = _objectSpread(_objectSpread(_objectSpread({
            data_url: reportInfoByCodeData.data_url,
            data_param: JSON.stringify(data_param)
          }, report_param), obj), {}, {
            reqMethod: 0,
            Authorization: token ? "Bearer ".concat(token) : ''
          });

          createForm("".concat(ReportServerUrl, "?report_code=").concat(report_code, "&reportlet=").concat(reportInfoByCodeData.reportlet, "&fr_locale=zh_CN&timestamp=").concat(new Date().valueOf()), _param, "".concat(t.iframeName));
        }
      })["catch"](function (err) {
        return console.log(err);
      });
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: styles.iframeParent
      }, /*#__PURE__*/_react["default"].createElement("iframe", {
        className: 'wrapper',
        width: "100%",
        height: "100%",
        name: "".concat(this.iframeName)
      }));
    }
  }]);

  return VtxRpsFrame;
}(_react["default"].Component);

var _default = VtxRpsFrame;
exports["default"] = _default;

var createForm = function createForm(reqURL, param, iframeName) {
  var formDom = $("<form>"); //定义一个form表单

  formDom.attr("style", "display:none");
  formDom.attr("target", iframeName);
  formDom.attr("method", "post");
  formDom.attr("action", reqURL);
  var inputArray = [];

  for (var k in param) {
    var input1 = $("<input>");
    input1.attr("type", "hidden");
    input1.attr("name", k);
    input1.attr("value", param[k]);
    inputArray.push(input1);
  }

  $("body").append(formDom); //将表单放置在web中

  for (var i = 0, len = inputArray.length; i < len; i++) {
    formDom.append(inputArray[i]);
  }

  formDom.submit(); //表单提交

  formDom.remove();
};

module.exports = exports["default"];
//# sourceMappingURL=VtxRpsFrame.js.map
