"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _default = _interopRequireDefault(require("../default"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = _defineProperty({}, 'vtx-ui-uedit', 'vtx-ui-uedit');

var VtxUeditor = /*#__PURE__*/function (_React$Component) {
  _inherits(VtxUeditor, _React$Component);

  var _super = _createSuper(VtxUeditor);

  function VtxUeditor(props) {
    var _this;

    _classCallCheck(this, VtxUeditor);

    _this = _super.call(this, props);
    _this.id = props.id || "vtx-ui-uedit".concat(new Date().getTime() + Math.random());
    _this.state = {};
    _this.ue = null;

    _this.loadMapJs();

    return _this;
  }

  _createClass(VtxUeditor, [{
    key: "loadMapJs",
    value: function loadMapJs() {
      var t = this;
      window.UEDITOR_HOME_URL = _default["default"].ueditorServer;
      this.loadUEComplete = new Promise(function (resolve, reject) {
        if (window.UE) {
          resolve(window.UE);
        } else {
          var Config = new Promise(function (resolve, reject) {
            $.getScript("".concat(_default["default"].ueditorServer, "ueditor.config.js"), function () {
              /* 
                  maximumWords 总字符数 10000
                  zIndex: 900
              */
              window.UEDITOR_CONFIG = _objectSpread(_objectSpread({}, window.UEDITOR_CONFIG), {}, {
                maxUndoCount: 50,
                maxInputCount: 20,
                serverUrl: "/".concat(t.props.serverUrlprefix || 'editorURL', "/jsp/controller.jsp")
              }, t.props.config);
              resolve();
            });
          });
          var Ueditor = new Promise(function (resolve, reject) {
            $.getScript("".concat(_default["default"].ueditorServer, "ueditor.all.js"), function () {
              // resolve();
              $.getScript("".concat(_default["default"].ueditorServer, "ueditor.parse.js"), function () {
                resolve();
              });
            });
          });
          Promise.all([Ueditor, Config]).then(function () {
            resolve(window.UE);
          });
        }
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var t = this;
      t.loadUEComplete.then(function () {
        t.init();
      });
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      if ((0, _isEqual["default"])(t.props, nextProps)) {
        return false;
      }

      return true;
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.setParam(nextProps);
    } // 初始化

  }, {
    key: "init",
    value: function init() {
      this.ue = window.UE.getEditor(this.id);
      this.setParam(this.props);
    } // 设置参数

  }, {
    key: "setParam",
    value: function setParam(option) {
      var t = this;

      if (this.ue) {
        this.ue.ready(function () {
          // 初始化数据
          t.ue.setContent(option.value || '');

          if (option.disabled) {
            t.ue.setDisabled();
          } else {
            t.ue.setEnabled();
          }
        });
      }
    } // 获取html文本

  }, {
    key: "getContent",
    value: function getContent() {
      return this.ue.getContent();
    }
  }, {
    key: "render",
    value: function render() {
      var t = this;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: styles['vtx-ui-uedit'],
        id: this.id
      });
    }
  }]);

  return VtxUeditor;
}(_react["default"].Component);

exports["default"] = VtxUeditor;
module.exports = exports["default"];
//# sourceMappingURL=index.js.map
